' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright

VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   8280
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   8280
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox catf 
      Height          =   375
      Left            =   240
      TabIndex        =   6
      Text            =   "samplecat"
      Top             =   6240
      Width           =   4335
   End
   Begin VB.TextBox dbf 
      Height          =   405
      Left            =   240
      TabIndex        =   5
      Text            =   "sampledb"
      Top             =   5760
      Width           =   4335
   End
   Begin VB.TextBox pwdf 
      Height          =   375
      IMEMode         =   3  'DISABLE
      Left            =   240
      PasswordChar    =   "*"
      TabIndex        =   4
      Text            =   "password"
      Top             =   5280
      Width           =   4335
   End
   Begin VB.TextBox idf 
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Text            =   "frnadmin"
      Top             =   4800
      Width           =   4335
   End
   Begin VB.TextBox srvf 
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Text            =   "qbicsnp"
      Top             =   4320
      Width           =   4335
   End
   Begin VB.CommandButton go 
      Caption         =   "go"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   975
      Left            =   120
      TabIndex        =   1
      Top             =   7080
      Width           =   4455
   End
   Begin VB.ListBox status 
      Height          =   3960
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   4455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub cout(s As String)
    status.AddItem s
    status.Refresh
End Sub

Private Sub go_Click()
    cout "begin..."
    Dim str As String
    Dim dsQBIC As New DXDatastoreQBIC
    cout "Datastore QBIC created"
    cout "connecting to datastore"
    dsQBIC.Connect srvf.Text, idf.Text, pwdf.Text
    cout "datastore connected"
    
    dsQBIC.openCatalog "SAMPLEDB", "SAMPLECAT"
    cout "catalog opened"
    dsQBIC.closeCatalog
    cout "catalog closed"

    str = dsQBIC.datastoreName()
    cout "QBIC datastore name is " & str

    cout "db name " & dbf.Text & " cat name " & catf.Text
    Dim dsdef As DXDatastoreDefQBIC
    Set dsdef = dsQBIC.datastoreDef
    cout "create database "
    Dim db As New DXDatabaseDefQBIC
    cout "db.setDatastore"
    db.setDatastore dsQBIC
    cout "db.setName: " & dbf.Text
    db.setName dbf.Text
    cout "add database " & dbf.Text
    dsdef.Add db
    cout "create catalog "
    Dim cat As New DXCatalogDefQBIC
    cat.setDatastore dsQBIC
    cat.setName catf.Text
    cout "add catalog " & catf.Text & " to database " & dbf.Text
    cat.setDatabaseName dbf.Text
    cat.Add
    cout "create feature "
    Dim feat As New DXFeatureDefQBIC
    feat.setDatastore dsQBIC
    feat.setDatabaseName dbf.Text
    feat.setCatalogName catf.Text
    feat.setEntity cat
    feat.setName "QbColor"
    cout "add feature QbColorFeatureClass to catalog " & catf.Text & " - database " & dbf.Text
    feat.Add

    dsQBIC.disconnect
    cout "datastore disconnected"
        
End Sub
