' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright

VERSION 5.00
Begin VB.Form TxdoSmsCrudDL 
   Caption         =   "TxdoSmsCrudDL"
   ClientHeight    =   10575
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9420
   LinkTopic       =   "TxdoSmsCrudDL"
   ScaleHeight     =   10575
   ScaleWidth      =   9420
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Readme 
      Caption         =   "Readme"
      Height          =   495
      Left            =   720
      TabIndex        =   12
      Top             =   8280
      Width           =   975
   End
   Begin VB.CommandButton ChangeSMS 
      Caption         =   "ChangeSMS"
      Height          =   495
      Left            =   3480
      TabIndex        =   11
      Top             =   9000
      Width           =   1215
   End
   Begin VB.CommandButton AddM 
      Caption         =   "Add-Media"
      Height          =   495
      Left            =   5160
      TabIndex        =   10
      Top             =   9840
      Width           =   975
   End
   Begin VB.CommandButton AddFS 
      Caption         =   "AddF-Srch"
      Height          =   495
      Left            =   3840
      TabIndex        =   9
      Top             =   9840
      Width           =   975
   End
   Begin VB.CommandButton AddBS 
      Caption         =   "AddB-Srch"
      Height          =   495
      Left            =   2640
      TabIndex        =   8
      Top             =   9840
      Width           =   975
   End
   Begin VB.CommandButton AddF 
      Caption         =   "AddF"
      Height          =   435
      Left            =   1440
      TabIndex        =   7
      Top             =   9840
      Width           =   975
   End
   Begin VB.CommandButton RetrieveF 
      Caption         =   "RetrieveF"
      Height          =   495
      Left            =   1920
      TabIndex        =   6
      Top             =   9000
      Width           =   1095
   End
   Begin VB.CommandButton Delete 
      Caption         =   "Delete"
      Height          =   495
      Left            =   5040
      TabIndex        =   5
      Top             =   9000
      Width           =   1095
   End
   Begin VB.CommandButton RetrieveB 
      Caption         =   "RetrieveB"
      Height          =   495
      Left            =   240
      TabIndex        =   4
      Top             =   9000
      Width           =   1095
   End
   Begin VB.CommandButton AddB 
      Caption         =   "AddB"
      Height          =   495
      Left            =   240
      TabIndex        =   3
      Top             =   9840
      Width           =   975
   End
   Begin VB.CommandButton Disconnect 
      Caption         =   "Disconnect"
      Height          =   495
      Left            =   4440
      TabIndex        =   2
      Top             =   8280
      Width           =   1095
   End
   Begin VB.CommandButton Connect 
      Caption         =   "Connect"
      Height          =   495
      Left            =   2520
      TabIndex        =   1
      Top             =   8280
      Width           =   1095
   End
   Begin VB.TextBox Results 
      Height          =   7815
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   240
      Width           =   7575
   End
End
Attribute VB_Name = "TxdoSmsCrudDL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Dim dsDL As DXDatastoreDL
Dim xdo As DXBlobDL
Dim pid As DXPidXDODL
Dim itemId As String
Dim partId As Integer
Dim repType As String
Dim fileName As String
Dim fileName2 As String
Dim lsName As String
Dim collectName As String
Dim collectName2 As String
Dim mgtClass As String
Dim stgClass As String
Dim retention As Long
Dim searchIndex As String
Dim contentClass As Long

Private Sub cout(str As String)
    Results.Text = Results.Text & Chr$(13) & Chr$(10) & str
End Sub

Private Sub Readme_Click()
   cout "This is a test case that test the add/retrieve/delete/change of an object "
   cout "which has association with different storage collection in DL.           "
   cout " "
   cout "To add an object to associate with other SMS collection, you need to do "
   cout "following to define a SMS collection:"
   cout " "
   cout " 1. bring up DL SMS server "
   cout " 2. bring up System Admin Client "
   cout " 3. create migration policy(managementClass) SMSMGT1 with "
   cout "    retension period = 30 days & storage calss = FIXED "
   cout " 4. create workstation collection SMSCOLLECT1 with "
   cout "    migration policy = SMSMGT1 & storage group = GROUP01 "
   cout " 5. shut down Object Server and bring up Object Server for "
   cout "    you to be able use the newly defined collection name  "
   cout " 6. pick a known itemId from sample loader's output log "
   cout "  "
   cout "Buttons: "
   cout "  Connect    - connect to datastore"
   cout "  Disconnect - disconnect to datastore"
   cout "  AddB       - add object from buffer"
   cout "  AddF       - add object from file"
   cout "  AddB-Srch  - add object from buffer to be search indexed"
   cout "  AddF-Srch  - add object from file to be search indexed"
   cout "  Add-Media  - add the media object"
   cout "  RetrieveB  - retrieve object to buffer"
   cout "  RetrieveF  - retrieve object to file"
   cout "  ChangeSMS  - change the storage collection of an object"
   cout "  Delete     - delete object from persistant datastore"
   cout " "
   cout "Hard coded: following are hard coded, you need to change them to fit your setup "
   cout " important note: "
   cout "   1. For AddB & AddF, you can set partId = 0 to let system to generate one for your"
   cout "      new added object.  For other Add, you need to specify an unused partId.  "
   cout "   2. For AddB-Srch & AddF-Srch, make sure the search index is defined in the system "
   cout "      and  search server is up. "
   cout "   3. Modify the fileName to a file you have with full path."
   cout " "
   itemId = "DXGJJXJOA789ESOE"
   partId = 25
   repType = "FRN$NULL"
   lsName = "LIBSRVRP"
   collectName = "CBR.MEICOLLECT1"
   collectName2 = "CBR.CLLCT002"
   mgtClass = "MEIMGT1"
   stgClass = "FIXED"
   retention = 789
   fileName = "e:\\dlv200j\\test\\notepart.txt"
   fileName2 = "fileRet.f1"
   searchIndex = "TM-TMINDEX"
   contentClass = DX_DL_CC_ASCII
   cout "  itemId               = " & itemId
   cout "  partId               = " & partId
   cout "  LS serverName        = " & lsName
   cout "  SMS collectionName   = " & collectName
   cout "  SMS collectionName (for changeSMS)   = " & collectName2
   cout "  SMS manageClassName  = " & mgtClass
   cout "  SMS storageClassName = " & stgClass
   cout "  SMS retention period = " & retention
   cout "  fileName to be add   = " & fileName
   cout "  retrieved fileName   = " & fileName2
   cout "  search index         = " & searchIndex
   cout "  contentClass         = " & contentClass
End Sub

Private Sub Connect_Click()

    Results.Text = ""

    
   If rentention = 0 Then
    itemId = "DXGJJXJOA789ESOE"
    partId = 30
    repType = "FRN$NULL"
    lsName = "LIBSRVRP"
    collectName = "CBR.MEICOLLECT1"
    collectName2 = "CBR.CLLCT002"
    mgtClass = "MEIMGT1"
    stgClass = "FIXED"
    retention = 789
    fileName = "e:\\dlv200j\\test\\notepart.txt"
    fileName2 = "fileRet.f1"
    searchIndex = "TM-TMINDEX"
    contentClass = DX_DL_CC_ASCII
   End If
    Set dsDL = New DXDatastoreDL
    Set xdo = New DXBlobDL
    Set pid = New DXPidXDODL
    On Error GoTo Errors
    xdo.init dsDL
    xdo.setPartId partId
    xdo.setItemId itemId
    xdo.setRepType repType

    cout "Connecting to datastore of DL in " & lsName
    dsDL.Connect lsName, "FRNADMIN", "PASSWORD", ""
    On Error GoTo Errors
    cout "===Datastore connected==="
    cout " "
    cout " "
    cout "Following are the setup: "
    cout "  itemId               = " & itemId
    cout "  partId               = " & partId
    cout "  fileName to be add   = " & fileName
    cout "  retrieved fileName   = " & fileName2
    cout "  LS serverName        = " & lsName
    cout "  SMS collectionName   = " & collectName
    cout "  SMS collectionName (for changeSMS)   = " & collectName2
    cout "  SMS manageClassName  = " & mgtClass
    cout "  SMS storageClassName = " & stgClass
    cout "  SMS retention period = " & retention
    cout "  search index         = " & searchIndex
    cout "  contentClass         = " & contentClass

    Disconnect.Enabled = True
    Connect.Enabled = False
    AddB.Enabled = True
    AddF.Enabled = True
    AddBS.Enabled = True
    AddFS.Enabled = True
    AddM.Enabled = True
    RetrieveB.Enabled = True
    RetrieveF.Enabled = True
    Delete.Enabled = True
    ChangeSMS.Enabled = True
    
    Exit Sub
Errors:
      cout "Errors:" & str(Err.Number) & Err.Description
    
End Sub

Private Sub Disconnect_Click()
    Results.Text = ""
    cout " "
    cout "disconnect from DL server"
    dsDL.Disconnect
    On Error GoTo Errors
    cout " "
    cout "===datastore disconnected==="
    Disconnect.Enabled = False
    Connect.Enabled = True
    AddB.Enabled = False
    AddF.Enabled = False
    AddBS.Enabled = False
    AddFS.Enabled = False
    AddM.Enabled = False
    RetrieveB.Enabled = False
    RetrieveF.Enabled = False
    Delete.Enabled = False
    ChangeSMS.Enabled = False

  Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description
End Sub


Private Sub AddB_Click()
    Results.Text = ""

    cout "itemId = " & xdo.getItemId
    cout "partId = " & xdo.getPartId
    cout "repType = " & xdo.getRepType
    cout "contentClass = " & xdo.getContentClass
    cout "fileName for add = " & fileName
    cout " "
    cout "==setup DXStorageManageInfoDL===:"
    Dim sms As New DXStorageManageInfoDL
    sms.setRetention retention
    sms.setCollectionName collectName
    sms.setManagementClass mgtClass
    sms.setStorageClass stgClass
    cout "  set sms extension obj..."
    xdo.setExtension sms
    On Error GoTo Errors

    cout "  set contentClass & setcontent..."
    xdo.setContentClass contentClass
    xdo.setContentFromClientFile fileName
    On Error GoTo Errors
    cout " "
    cout "about to add()..."
    xdo.Add
    On Error GoTo Errors
    cout "add successfully..."
    cout " "
    cout "after added partId = " & xdo.getPartId

    Disconnect.Enabled = True
    Connect.Enabled = False
    AddB.Enabled = False
    AddF.Enabled = False
    AddBS.Enabled = False
    AddFS.Enabled = False
    AddM.Enabled = False
    RetrieveB.Enabled = True
    RetrieveF.Enabled = True
    Delete.Enabled = True
    ChangeSMS.Enabled = True

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub


Private Sub AddBS_Click()

    Results.Text = ""

    cout "itemId = " & xdo.getItemId
    cout "partId = " & xdo.getPartId
    cout "repType = " & xdo.getRepType
    cout "contentClass = " & xdo.getContentClass
    cout "fileName for add = " & fileName
    cout " "
    cout "==setup DXStorageManageInfoDL===:"
    Dim sms As New DXStorageManageInfoDL
    sms.setRetention retention
    sms.setCollectionName collectName
    sms.setManagementClass mgtClass
    sms.setStorageClass stgClass
    cout "  set sms extension obj..."
    xdo.setExtension sms
    On Error GoTo Errors
   
    cout " "
    cout "==setup DXSearchEngingInfoDL===:"
    Dim srcheng As New DXSearchEngineInfoDL
    srcheng.setSearchEngine "SM"
    srcheng.setSearchInfo "ENU"
    'srcheng.setSearchIndex "TMMUF-TMINDEX"
    srcheng.setSearchIndex searchIndex
    cout "  set srcheng extension obj..."
    xdo.setExtension srcheng
    On Error GoTo Errors

    cout "  set contentClass & setcontent..."
    xdo.setContentClass contentClass
    xdo.setContentFromClientFile fileName
    On Error GoTo Errors
    
    cout "about to add()..."
    xdo.Add
    On Error GoTo Errors
    cout "add successfully..."
    cout "after added partId = " & xdo.getPartId

    Disconnect.Enabled = True
    Connect.Enabled = False
    AddB.Enabled = False
    AddF.Enabled = False
    AddBS.Enabled = False
    AddFS.Enabled = False
    AddM.Enabled = False
    RetrieveB.Enabled = True
    RetrieveF.Enabled = True
    Delete.Enabled = True
    ChangeSMS.Enabled = True

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub



Private Sub AddF_Click()
    Results.Text = ""

    cout "itemId = " & xdo.getItemId
    cout "partId = " & xdo.getPartId
    cout "repType = " & xdo.getRepType
    cout "contentClass = " & xdo.getContentClass
    cout "fileName for add = " & fileName
    cout " "
    cout "==setup DXStorageManageInfoDL===:"
    Dim sms As New DXStorageManageInfoDL
    sms.setRetention retention
    sms.setCollectionName collectName
    sms.setManagementClass mgtClass
    sms.setStorageClass stgClass
    cout "  set sms extension obj..."
    xdo.setExtension sms
    On Error GoTo Errors

    cout "  set contentClass..."
    xdo.setContentClass contentClass
    On Error GoTo Errors
    cout " "
    cout "about to add(fileName)..."
    xdo.Add fileName
    On Error GoTo Errors
    cout "add successfully..."
    cout "after added partId = " & xdo.getPartId

    Disconnect.Enabled = True
    Connect.Enabled = False
    AddB.Enabled = False
    AddF.Enabled = False
    AddBS.Enabled = False
    AddFS.Enabled = False
    AddM.Enabled = False
    RetrieveB.Enabled = True
    RetrieveF.Enabled = True
    Delete.Enabled = True
    ChangeSMS.Enabled = True

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub


Private Sub AddFS_Click()
    Results.Text = ""

    cout "itemId = " & xdo.getItemId
    cout "partId = " & xdo.getPartId
    cout "repType = " & xdo.getRepType
    cout "contentClass = " & xdo.getContentClass
    cout "fileName for add = " & fileName
    cout " "
    cout "==setup DXStorageManageInfoDL===:"
    Dim sms As New DXStorageManageInfoDL
    sms.setRetention retention
    sms.setCollectionName collectName
    sms.setManagementClass mgtClass
    sms.setStorageClass stgClass
    cout "  set sms extension obj..."
    xdo.setExtension sms
    On Error GoTo Errors

    cout " "
    cout "==setup DXSearchEngingInfoDL===:"
    Dim srcheng As New DXSearchEngineInfoDL
    srcheng.setSearchEngine "SM"
    srcheng.setSearchInfo "ENU"
    'srcheng.setSearchIndex "TMMUF-TMINDEX"
    srcheng.setSearchIndex searchIndex
    cout "  set srcheng extension obj..."
    xdo.setExtension srcheng
    On Error GoTo Errors

    cout "  set contentClass... "
    xdo.setContentClass contentClass
    On Error GoTo Errors
    
    cout "about to add(fileName)..."
    xdo.Add fileName
    On Error GoTo Errors
    cout "add successfully..."
    cout "after added partId = " & xdo.getPartId

    Disconnect.Enabled = True
    Connect.Enabled = False
    AddB.Enabled = False
    AddF.Enabled = False
    AddBS.Enabled = False
    AddFS.Enabled = False
    AddM.Enabled = False
    RetrieveB.Enabled = True
    RetrieveF.Enabled = True
    Delete.Enabled = True
    ChangeSMS.Enabled = True

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description
End Sub


Private Sub AddM_Click()

    Results.Text = ""

    cout "itemId = " & xdo.getItemId
    cout "partId = " & xdo.getPartId
    cout "repType = " & xdo.getRepType
    cout "contentClass = " & xdo.getContentClass
    cout "fileName for add = " & fileName
    cout " "
    cout "==setup DXStorageManageInfoDL===:"
    Dim sms As New DXStorageManageInfoDL
    sms.setRetention retention
    sms.setCollectionName collectName
    sms.setManagementClass mgtClass
    sms.setStorageClass stgClass
    cout "  set sms extension obj..."
    xdo.setExtension sms
    On Error GoTo Errors

    cout " "
    cout "===setup DXMediaStreamInfoDL==="
    Dim aVS As New DXMediaStreamInfoDL
    aVS.setMediaFullFileName fileName
    'aVS.setMediaObjectOption  DK_VS_LIST_OF_OBJECT_SEGMENTS
    aVS.setMediaObjectOption DK_VS_SINGLE_OBJECT
    aVS.setMediaHostName "vcharger1.stl.ibm.com"
    aVS.setMediaUserId "root"
    aVS.setMediaPassword "video4me"
    aVS.setMediaNumberOfUsers 1
    aVS.setMediaAssetGroup "AG"
    aVS.setMediaType "MOV"
    aVS.setMediaResolution "SIF"
    aVS.setMediaStandard "NTSC"
    aVS.setMediaFormat "SYSTEM"
    cout "  set media extension obj..."
    xdo.setExtension aVS
    On Error GoTo Errors

    cout "  set contentClass... "
    xdo.setContentClass DX_DL_CC_IBMVSS
    On Error GoTo Errors
    
    cout "about to add()..."
    xdo.Add
    On Error GoTo Errors
    cout "add successfully..."
    cout "after added partId = " & xdo.getPartId

    Disconnect.Enabled = True
    Connect.Enabled = False
    AddB.Enabled = False
    AddF.Enabled = False
    AddBS.Enabled = False
    AddFS.Enabled = False
    AddM.Enabled = False
    RetrieveB.Enabled = True
    RetrieveF.Enabled = True
    Delete.Enabled = True
    ChangeSMS.Enabled = True

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description
End Sub


Private Sub ChangeSMS_Click()

    Results.Text = ""

    cout "itemId = " & xdo.getItemId
    cout "partId = " & xdo.getPartId
    cout "repType = " & xdo.getRepType

    cout "==setup DXStorageManageInfoDL===:"
    Dim sms As New DXStorageManageInfoDL
    sms.setRetention 7788
    sms.setCollectionName collectName2
    sms.setManagementClass mgtClass
    sms.setStorageClass stgClass
    cout "  retention      = " & sms.getRetention
    cout "  collectionName = " & sms.getCollectionName
    cout "  MgtClass       = " & sms.getManagementClass
    cout "  StgClass       = " & sms.getStorageClass
    cout " "
    cout "  set sms extension obj..."
    xdo.setExtension sms
    On Error GoTo Errors
    
    cout "about to call changeStorage()..."
    xdo.changeStorage
    On Error GoTo Errors
    cout "changeStorage() success..."

    Disconnect.Enabled = True
    Connect.Enabled = False
    AddB.Enabled = False
    AddF.Enabled = False
    AddBS.Enabled = False
    AddFS.Enabled = False
    AddM.Enabled = False
    RetrieveB.Enabled = True
    RetrieveF.Enabled = True
    Delete.Enabled = True
    ChangeSMS.Enabled = True

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description


End Sub



Private Sub Delete_Click()

    Results.Text = ""
    'pid = xdo.getPidObject
    cout "itemId=" & xdo.getItemId
    cout "partId=" & xdo.getPartId

    Dim mflag As Boolean
    mflag = xdo.isCategoryOf(DX_DL_MEDIA_OBJECT)
    cout "isCategoryOf media obj = " & mflag
    If (mflag) Then
     cout "setting delete Option for media object ..."
     xdo.setOption DX_DL_OPT_DELETE_OPTION, DX_DL_DELETE_NO_DROPITEM_MEDIA_AVAIL
     Dim ln As Variant
     xdo.getOption DX_DL_OPT_DELETE_OPTION, ln
     cout "getOption deleteOpt=" & ln
    End If
    cout "===about to call delete==="
    xdo.del
    cout "  delete successfully"
    cout "===after  delete==="
    mflag = xdo.isCategoryOf(DX_DL_MEDIA_OBJECT)
    cout "  isCategoryOf media obj = " & mflag

    Disconnect.Enabled = True
    Connect.Enabled = False
    AddB.Enabled = True
    AddF.Enabled = True
    AddBS.Enabled = True
    AddFS.Enabled = True
    AddM.Enabled = True
    RetrieveB.Enabled = False
    RetrieveF.Enabled = Fale
    Delete.Enabled = False
    ChangeSMS.Enabled = False

    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub



Private Sub RetrieveB_Click()
    Results.Text = ""
    cout "itemId=" & xdo.getItemId
    cout "partId=" & xdo.getPartId
    cout "repType=" & xdo.getRepType

    cout "===before retrieve==="
    'should be length=0
    cout " length=" & xdo.length
    cout " getSize=" & xdo.getSize
    cout " updatedTimestamp=" & xdo.getUpdatedTimestamp
    cout " createdTimestamp=" & xdo.getCreatedTimestamp
    cout " mimeType=" & xdo.getMimeType
    cout "===about to retrieve()==="
    xdo.retrieve
    On Error GoTo Errors
    cout "  retrieve successfully..."

    cout "==Check if this is an indexed part==="
    Dim catflag As Boolean
    catflag = xdo.isCategoryOf(DX_DL_INDEXED_OBJECT)
    cout "isCategoryOf indexed obj = " & catflag
    If (catflag) Then
      cout " ==alreay indexed, do getExtension to show informations:"
      Dim srcheng2 As Variant
      Set srcheng2 = xdo.getExtension("DXSearchEngineInfoDL")
      On Error GoTo Errors
      cout " srcheng2.getSearchEngine=" & srcheng2.getSearchEngine
      cout " srcheng2.getSearchIndex=" & srcheng2.getSearchIndex
      cout " srcheng2.getSearchInfo=" & srcheng2.getSearchInfo
      cout " srcheng2.getTextIndex=" & srcheng2.getTextIndex
      cout " srcheng2.getCatalog=" & srcheng2.getCatalog
      cout " srcheng2.getDataBase=" & srcheng2.getDataBase
      cout " srcheng2.getServerName=" & srcheng2.getServerName
      cout " srcheng2.getSearchClassId=" & srcheng2.getSearchClassId
      cout " srcheng2.getSearchTimestamp=" & srcheng2.getSearchTimestamp
      cout " xdo.retrieveObjectState=" & xdo.retrieveObjectState(DX_DL_INDEXED_OBJECT)
    End If

    cout "==Check if this is an media object==="
    Dim mflag As Boolean
    mflag = xdo.isCategoryOf(DX_DL_MEDIA_OBJECT)
    cout "isCategoryOf media obj = " & mflag
    If (mflag) Then
      cout " == is a media object, get mediaStream extension obj..."
      Dim aVS2 As Variant
      Set aVS2 = xdo.getExtension("DXMediaStreamInfoDL")
      On Error GoTo Errors
      cout " aVS2.getMediaCopyRate=" & aVS2.getMediaCopyRate
      cout " aVS2.getMediaInvalidCommands=" & aVS2.getMediaInvalidCommands
      cout " aVS2.getMediaDurSeconds=" & aVS2.getMediaDurSeconds
      cout " aVS2.getMediaDurFrames=" & aVS2.getMediaDurFrames
      cout " aVS2.getMediaFrameRate=" & aVS2.getMediaFrameRate
      cout " aVS2.getMediaBitRate=" & aVS2.getMediaBitRate
      cout " aVS2.getMediaNumberOfUsers=" & aVS2.getMediaNumberOfUsers
      cout " aVS2.getMediaAssetGroup=" & aVS2.getMediaAssetGroup
      cout " aVS2.getMediaType=" & aVS2.getMediaType
      cout " aVS2.getMediaResolution=" & aVS2.getMediaResolution
      cout " aVS2.getMediaStandard=" & aVS2.getMediaStandard
      cout " aVS2.getMediaFormat=" & aVS2.getMediaFormat
      cout " aVS2.getMediaState=" & aVS2.getMediaState
      cout "xdo.retrieveObjectState(media) =" & xdo.retrieveObjectState(DX_DL_MEDIA_OBJECT)
      On Error GoTo Errors
    End If

    cout "===after retrieve==="
    cout " length=" & xdo.length
    cout " getSize=" & xdo.getSize
    cout " updatedTimestamp=" & xdo.getUpdatedTimestamp
    cout " createdTimestamp=" & xdo.getCreatedTimestamp
    cout " mimeType=" & xdo.getMimeType

    cout "==get DXStorageManageInfoDL SMS information==="
    cout " do getExtension to show informations:"
    Dim sms2 As Variant
    Set sms2 = xdo.getExtension("DXStorageManageInfoDL")
    On Error GoTo Errors
    cout " sms2.getCollectionName=" & sms2.getCollectionName
    cout " sms2.getManagementClass=" & sms2.getManagementClass
    cout " sms2.getStorageClass=" & sms2.getStorageClass
    cout " sms2.getRetention=" & sms2.getRetention
    cout " sms2.getStoreSite=" & sms2.getStoreSite

    Disconnect.Enabled = True
    Connect.Enabled = False
    AddB.Enabled = False
    AddF.Enabled = False
    AddBS.Enabled = False
    AddFS.Enabled = False
    AddM.Enabled = False
    RetrieveB.Enabled = True
    RetrieveF.Enabled = True
    Delete.Enabled = True
    ChangeSMS.Enabled = True
  
    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub



Private Sub RetrieveF_Click()

    Results.Text = ""
    cout "itemId=" & xdo.getItemId
    cout "partId=" & xdo.getPartId
    cout "repType=" & xdo.getRepType
   cout "retrieved fileName=" & fileName2

    cout "===before retrieve==="
    'should be length=0
    cout " length=" & xdo.length
    cout " getSize=" & xdo.getSize
    cout " updatedTimestamp=" & xdo.getUpdatedTimestamp
    cout " createdTimestamp=" & xdo.getCreatedTimestamp
    cout " mimeType=" & xdo.getMimeType
    cout "===about to retrieve(fileName2)==="
    xdo.retrieve fileName2
    On Error GoTo Errors
    cout "  retrieve successfully..."

    cout "==Check if this is an indexed part==="
    Dim catflag As Boolean
    catflag = xdo.isCategoryOf(DX_DL_INDEXED_OBJECT)
    cout "isCategoryOf indexed obj = " & catflag
    If (catflag) Then
      cout " ==alreay indexed, do getExtension to show informations:"
      Dim srcheng2 As Variant
      Set srcheng2 = xdo.getExtension("DXSearchEngineInfoDL")
      On Error GoTo Errors
      cout " srcheng2.getSearchEngine=" & srcheng2.getSearchEngine
      cout " srcheng2.getSearchIndex=" & srcheng2.getSearchIndex
      cout " srcheng2.getSearchInfo=" & srcheng2.getSearchInfo
      cout " srcheng2.getTextIndex=" & srcheng2.getTextIndex
      cout " srcheng2.getCatalog=" & srcheng2.getCatalog
      cout " srcheng2.getDataBase=" & srcheng2.getDataBase
      cout " srcheng2.getServerName=" & srcheng2.getServerName
      cout " srcheng2.getSearchClassId=" & srcheng2.getSearchClassId
      cout " srcheng2.getSearchTimestamp=" & srcheng2.getSearchTimestamp
      cout " xdo.retrieveObjectState=" & xdo.retrieveObjectState(DX_DL_INDEXED_OBJECT)
    End If

    cout "==Check if this is an media object==="
    Dim mflag As Boolean
    mflag = xdo.isCategoryOf(DX_DL_MEDIA_OBJECT)
    cout "isCategoryOf media obj = " & mflag
    If (mflag) Then
      cout " == is a media object, get mediaStream extension obj..."
      Dim aVS2 As Variant
      Set aVS2 = xdo.getExtension("DXMediaStreamInfoDL")
      On Error GoTo Errors
      cout " aVS2.getMediaCopyRate=" & aVS2.getMediaCopyRate
      cout " aVS2.getMediaInvalidCommands=" & aVS2.getMediaInvalidCommands
      cout " aVS2.getMediaDurSeconds=" & aVS2.getMediaDurSeconds
      cout " aVS2.getMediaDurFrames=" & aVS2.getMediaDurFrames
      cout " aVS2.getMediaFrameRate=" & aVS2.getMediaFrameRate
      cout " aVS2.getMediaBitRate=" & aVS2.getMediaBitRate
      cout " aVS2.getMediaNumberOfUsers=" & aVS2.getMediaNumberOfUsers
      cout " aVS2.getMediaAssetGroup=" & aVS2.getMediaAssetGroup
      cout " aVS2.getMediaType=" & aVS2.getMediaType
      cout " aVS2.getMediaResolution=" & aVS2.getMediaResolution
      cout " aVS2.getMediaStandard=" & aVS2.getMediaStandard
      cout " aVS2.getMediaFormat=" & aVS2.getMediaFormat
      cout " aVS2.getMediaState=" & aVS2.getMediaState
      cout "xdo.retrieveObjectState(media) =" & xdo.retrieveObjectState(DX_DL_MEDIA_OBJECT)
      On Error GoTo Errors
    End If

    cout "===after retrieve==="
    'should be length=0 also
    cout " length=" & xdo.length
    cout " getSize=" & xdo.getSize
    cout " updatedTimestamp=" & xdo.getUpdatedTimestamp
    cout " createdTimestamp=" & xdo.getCreatedTimestamp
    cout " mimeType=" & xdo.getMimeType

    cout "===get DXStorageManageInfoDL SMS information==="
    cout " do getExtension to show informations:"
    Dim sms2 As Variant
    Set sms2 = xdo.getExtension("DXStorageManageInfoDL")
    On Error GoTo Errors
    cout " sms2.getCollectionName=" & sms2.getCollectionName
    cout " sms2.getManagementClass=" & sms2.getManagementClass
    cout " sms2.getStorageClass=" & sms2.getStorageClass
    cout " sms2.getRetention=" & sms2.getRetention
    cout " sms2.getStoreSite=" & sms2.getStoreSite

    Disconnect.Enabled = True
    Connect.Enabled = False
    AddB.Enabled = False
    AddF.Enabled = False
    AddBS.Enabled = False
    AddFS.Enabled = False
    AddM.Enabled = False
    RetrieveB.Enabled = True
    RetrieveF.Enabled = True
    Delete.Enabled = True
    ChangeSMS.Enabled = True
  
    Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description

End Sub







