/*
 * @copyright(disclaimer) 
 * Licensed Materials - Property of IBM
 * IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
 * 
 * US Government Users Restricted Rights                                  
 *  Use, duplication or disclosure restricted by GSA ADP Schedule          
 *  Contract with IBM Corp.     
 * 
 * DISCLAIMER OF WARRANTIES :                                             
 *                                                                        
 * Permission is granted to copy and modify this  Sample code, and to           
 * distribute modified versions provided that both the copyright        
 * notice,- and this permission notice and warranty disclaimer  appear in all copies and modified  
 * versions. 
 * 
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
 * IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM     
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN 
 * SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF 
 * NON-INFRINGEMENT AND THE IMPLIED WARRANTIES 
 * OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR 
 * PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR
 * SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT 
 * OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, 
 * DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION 
 * OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO 
 * EVENT SHALL IBM OR ITS LICENSORS AND SUPPLIERS BE 
 * LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, 
 * OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,
 * INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED 
 * AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF 
 * IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGES.                                     
 *                                                                  
 * @endCopyright
 */
/**
 * Translatable non-strings, e.g, images.
 * Strings are defined in other resource bundles.
 *
 * There is one version of this file
 * for each country.
 
 * 
 * Resources are defined in a two-dimensional array named contents.  The first
 * column of each row (contents[i,0]) is a key which is used to retrieve the
 * resource.  The second column (contents[i,1]) is the object associated with
 * the key.
 * <P>
 * The key (contents[i,0]) is free format, e.g., "mainImage"
 *
 */


public class CAOtherResources extends java.util.ListResourceBundle {

   // Do not remove - needed for copyright protection
   private static String COPYRIGHT = ClientPane.IBM_LONG_COPYRIGHT;

   public Object[][] getContents() {
           return contents;
   }

   private static final Object[][] contents = {
      {"REFRESH_TEMPLATES", "RefreshTemplates.gif"},
      {"STOP", "Stop.gif"},
      {"CLEAR_SEARCH", "ClearSearch.gif"},
      {"SEARCH", "Search.gif"},
      {"HELP", "Help.gif"},
      {"RESET_DEFAULTS", "ResetDefaults.gif"},
      {"CC_SPLASH", "ccicon.gif"},
      {"CC_LOGON", "cclogon.gif"},
      {"OPTIONS", "Options.gif"}

   };
}
